// Virtual Game Base Class.

#include "userDef.h"
#include <stdint.h>

#ifndef BOARD_HEIGHT
#define BOARD_HEIGHT    16
#endif
#ifndef BOARD_WIDTH
#define BOARD_WIDTH     16
#endif

#define NUM_PIXELS BOARD_HEIGHT * BOARD_WIDTH

class Game {
  private:
    virtual void updatePos() = 0;

  protected:
    uint8_t posx;
    uint8_t posy;
    // The number of items in the game.
    uint8_t numItems;
    // The positions of all the items in the game.
    uint8_t history [NUM_PIXELS];

  public:
    Game() {}
    uint8_t getX();
    uint8_t getY();
    uint8_t getNumItems();
    uint8_t getHistory(uint8_t);

    virtual void newGame() = 0;
    virtual void playGame() = 0;
    virtual bool parseIR(uint32_t) = 0;
};
