#ifndef __SNAKE_H__
#define __SNAKE_H__

#include "userDef.h"
#include "Game.h"

#ifndef SNAKE_SPEED
#define SNAKE_SPEED  80
#endif

#ifndef SNAKE_START_LENGTH
#define SNAKE_START_LENGTH  3
#endif

// Directions are same as a compass rose, NSEW, 1234
#define STOP            0
#define dirUP           1
#define dirRIGHT        2
#define dirDOWN         3
#define dirLEFT         4

class Snake : public Game {
  private:
    uint8_t snakePos;
    uint8_t foodPos;
    uint8_t count;
    uint8_t direction;

    bool isOpen(int);
    void genNewFood ();
    void updatePos();
    
  public:
    Snake();
    uint8_t getNumItems();

    void newGame();
    void playGame();
    bool parseIR(uint32_t);
};
#endif
